package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLQPolynomialFold_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLQPolynomialFold extends JNIObject  {
	
	/* @generated */
	protected ISLQPolynomialFold(long ptr) {
		/*** PROTECTED REGION ID(ISLQPolynomialFold_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLQPolynomialFold build(long ptr) {
		return new ISLQPolynomialFold(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLQPolynomialFold_userCode) ENABLED START ***/
	public List<ISLQPolynomial> getQPolynomials() {
		int n = this.getNbQPolynomials();
		List<ISLQPolynomial> res = new ArrayList<ISLQPolynomial>(n);
		for (int i = 0; i < n; i++) {
			res.add(this.getQPolynomialAt(i));
		}
		return res;
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_qpolynomial_fold_empty 
	 * 
	@take dim
	 * @generated
	**/
	 public static ISLQPolynomialFold buildEmpty(ISLFold type, ISLSpace dim) { 
		/*** PROTECTED REGION ID(static_isl_qpolynomial_fold_empty) DISABLED START ***/
		ISLQPolynomialFold res;
		
		synchronized(LOCK) {
			checkParameters(dim);
			try {
				res = ISLQPolynomialFold.build(ISLNative.isl_qpolynomial_fold_empty(type.getValue(), getNativePtr(dim)));
			} finally {
				taken(dim);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_qpolynomial_fold_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLQPolynomialFold qpf, int format) { 
		/*** PROTECTED REGION ID(static_isl_qpolynomial_fold_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_qpolynomial_fold_to_string(getNativePtr(qpf), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_qpolynomial_fold_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_qpolynomial_fold_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_qpolynomial_fold_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_qpolynomial_fold_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_qpolynomial_fold_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_qpolynomial_fold_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_qpolynomial_fold_copy 
	 * 
	 * @generated
	**/
	public ISLQPolynomialFold copy() {
		/*** PROTECTED REGION ID(isl_qpolynomial_fold_copy) DISABLED START ***/
		ISLQPolynomialFold res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLQPolynomialFold.build(ISLNative.isl_qpolynomial_fold_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_qpolynomial_fold_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_qpolynomial_fold_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_qpolynomial_fold_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_qpolynomial_fold_get_type 
	 * 
	 * @generated
	**/
	public ISLFold getType() {
		/*** PROTECTED REGION ID(isl_qpolynomial_fold_get_type) DISABLED START ***/
		ISLFold res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLFold.build(ISLNative.isl_qpolynomial_fold_get_type(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_qpolynomial_fold_is_empty 
	 * 
	 * @generated
	**/
	public boolean isEmpty() {
		/*** PROTECTED REGION ID(isl_qpolynomial_fold_is_empty) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_qpolynomial_fold_is_empty(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_qpolynomial_fold_plain_is_equal 
	 * 
	 * @generated
	**/
	public boolean isPlainEqual(ISLQPolynomialFold fold2) {
		/*** PROTECTED REGION ID(isl_qpolynomial_fold_plain_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_qpolynomial_fold_plain_is_equal(getNativePtr(this), getNativePtr(fold2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_qpolynomial_fold_gist 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLQPolynomialFold gist(ISLSet context) {
		/*** PROTECTED REGION ID(isl_qpolynomial_fold_gist) DISABLED START ***/
		ISLQPolynomialFold res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLQPolynomialFold.build(ISLNative.isl_qpolynomial_fold_gist(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_qpolynomial_fold_number_of_qpolynomial 
	 * 
	 * @generated
	**/
	public int getNbQPolynomials() {
		/*** PROTECTED REGION ID(isl_qpolynomial_fold_number_of_qpolynomial) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_qpolynomial_fold_number_of_qpolynomial(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_qpolynomial_fold_get_qpolynomial_at 
	 * 
	 * @generated
	**/
	public ISLQPolynomial getQPolynomialAt(int pos) {
		/*** PROTECTED REGION ID(isl_qpolynomial_fold_get_qpolynomial_at) DISABLED START ***/
		ISLQPolynomial res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLQPolynomial.build(ISLNative.isl_qpolynomial_fold_get_qpolynomial_at(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLQPolynomialFold_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
